﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;
using System.Windows.Forms;

namespace baryonswp
{
    public partial class Form1 : Form
    {
        private static Thread serviceThread;
        private bool running = false;

        public Form1()
        {
            InitializeComponent();
            CheckForIllegalCrossThreadCalls = false;
            Program.frm1 = this;
            this.Load += Form1_Load;
        }
        
        void Form1_Load(object sender, EventArgs e)
        {
            var ports = System.IO.Ports.SerialPort.GetPortNames();
            comboBox1.DataSource = ports;
        }
        
        public void LogToTextbox(string msg)
        {
            richTextBox1.Text += (msg+"\n");
            richTextBox1.SelectionStart = richTextBox1.TextLength;
            richTextBox1.ScrollToCaret();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (running) { LogToTextbox("Service is already running."); return; }
            if (!(textBox1.TextLength == 8) && !running) { LogToTextbox("Serial number must be 8 characters long."); return; }
            serviceThread = new Thread(() => Program.StartSerialEmulation(comboBox1.Text, textBox1.Text));
            
            running = true;

            serviceThread.Start();
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            
        }

        private void richTextBox1_TextChanged(object sender, EventArgs e)
        {
        }

        private void button2_Click_1(object sender, EventArgs e)
        {
            if (!running) return;
            LogToTextbox("Killing the service...");
            try { Program.serialPortInstance.Close(); }
            catch { LogToTextbox("WTF? Unable to kill! Something is super weird with the port, try again or restart the application..."); return; }
            running = false;
        }

        private void Form1_Load_1(object sender, EventArgs e)
        {

        }

        private void label3_Click(object sender, EventArgs e)
        {

        }

        private void label4_Click(object sender, EventArgs e)
        {

        }

        private void button6_Click(object sender, EventArgs e)
        {
            var ports = System.IO.Ports.SerialPort.GetPortNames();
            comboBox1.DataSource = ports;
        }

		private void textBox1_TextChanged(object sender, EventArgs e)
		{

		}

		private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
		{
            char c = e.KeyChar;
            if (textBox1.Text.Length >= 8) { e.Handled = true; return; }
            if (c >= 'a' && c <= 'f')
            {
                textBox1.Text += Char.ToUpper(c);
                e.Handled = true;
            } 
            else if (!((c >= '0' && c <= '9') || (c >= 'A' && c <= 'F')))
            {
                e.Handled = true;
            }
		}

		private void button5_Click(object sender, EventArgs e)
		{
            richTextBox1.Clear();
		}

		private void button3_Click(object sender, EventArgs e)
		{
			LogToTextbox("Please refer to the PSPx threads to restore your PSP™.");
            LogToTextbox("https://www.pspx.ru/forum/showthread.php?p=1229948 (Russian)");
            LogToTextbox("No english thread until layout in current one gets fixed, sorry!");
		}

		private void button4_Click(object sender, EventArgs e)
		{
            richTextBox1.Clear();
            LogToTextbox("BaryonSweeper R1 release!");
            LogToTextbox("Brought to you by patience and perserverance of:\n");
            LogToTextbox("M4j0r - Syscon Voltage Fault Injection glitch help\n");
            LogToTextbox("Wildcard, Sean Shablack - Syscon glitching and dumping\n");
            LogToTextbox("Proxima - Firmware reverse engineering, battery authentication response generator script\n");
            LogToTextbox("khubik - Emulator code, GUI design, authentication script porting\n");
            LogToTextbox("dogecore - Authentication script porting, GUI code, emulator threading fix\n");
            LogToTextbox("Mathieu Hervais - decrypt-sp & decrypt-OS2 homebrew code\n");
            LogToTextbox("SSL/Zerotolerance - re-encryption for Math's homebrews\n");
            LogToTextbox("zecoxao - decrypt-sp & decrypt-os2 PC ports, boards supply, authentication script porting help\n");
            LogToTextbox("Yoti - decrypt-sp improvements, MSID dumper, contribution to PSPx.ru's 3000 series JigKick hacking thread, PSP 3000 supplier (<3)\n");
            LogToTextbox("ErikPshat - Useful intel about JigKick, PSPx.ru's 3000 series JigKick hacking thread contribution, userguides for MSID dumping and JigKick memory card creation\n");
            LogToTextbox("Boryan, lport3, dx3d and many others from PSPx.ru's 3000 JigKick hacking thread - battery communication dumps and protocol reversal, one wire UART adapter schematics and more!\n");
            LogToTextbox("[!] Please do note that this tool is free and open-source. If you paid for it, demand a refund in full.\n");

            richTextBox1.SelectionStart = 0;
            richTextBox1.ScrollToCaret();
        }
	}
}
