﻿using System;
using System.Diagnostics;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO.Ports;
using System.Security.Cryptography;
using System.Runtime.InteropServices;
using Microsoft.Win32.SafeHandles;
using System.IO;
using System.Text;

namespace baryonswp
{
    static class Program
    {
        [DllImport("kernel32.dll")]
        static extern bool AttachConsole(int dwProcessId);
        private const int ATTACH_PARENT_PROCESS = -1;
        public static bool usingGui = false;
        public static Form1 frm1;
        public static SerialPort serialPortInstance = null;
        static byte[] msg;
        static byte[] response1a = new byte[8];
        static byte[] response1b = new byte[8]; // battery nonce
        static byte[] response2g = new byte[8];
        // OOH THE KEYS
        static readonly Dictionary<byte, byte[]> keystore = new Dictionary<byte, byte[]>()
            {
            { 0, new byte[] { 0x5C, 0x52, 0xD9, 0x1C, 0xF3, 0x82, 0xAC, 0xA4, 0x89, 0xD8, 0x81, 0x78, 0xEC, 0x16, 0x29, 0x7B } }, // 086
            { 1, new byte[] { 0x9D, 0x4F, 0x50, 0xFC, 0xE1, 0xB6, 0x8E, 0x12, 0x09, 0x30, 0x7D, 0xDB, 0xA6, 0xA5, 0xB5, 0xAA } }, // ???????
            { 2, new byte[] { 0x09, 0x75, 0x98, 0x88, 0x64, 0xAC, 0xF7, 0x62, 0x1B, 0xC0, 0x90, 0x9D, 0xF0, 0xFC, 0xAB, 0xFF } }, // 85v2 fallback
            { 3, new byte[] { 0xC9, 0x11, 0x5C, 0xE2, 0x06, 0x4A, 0x26, 0x86, 0xD8, 0xD6, 0xD9, 0xD0, 0x8C, 0xDE, 0x30, 0x59 } }, // ????????
            { 4, new byte[] { 0x66, 0x75, 0x39, 0xD2, 0xFB, 0x42, 0x73, 0xB2, 0x90, 0x3F, 0xD7, 0xA3, 0x9E, 0xD2, 0xC6, 0x0C } }, // 90, 93, 95, 96 autoboot
            { 5, new byte[] {0xF4, 0xFA, 0xEF, 0x20, 0xF4, 0xDB, 0xAB, 0x31, 0xD1, 0x86, 0x74, 0xFD, 0x8F, 0x99, 0x05, 0x66 } },  // ????????
            { 6, new byte[] {0xEA, 0x0C, 0x81, 0x13, 0x63, 0xD7, 0xE9, 0x30, 0xF9, 0x61, 0x13, 0x5A, 0x4F, 0x35, 0x2D, 0xDC } },  // ????????
            { 8, new byte[] {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 } },  // 85v2 
            { 0xA, new byte[] {0xAC, 0x00, 0xC0, 0xE3, 0xE8, 0x0A, 0xF0, 0x68, 0x3F, 0xDD, 0x17, 0x45, 0x19, 0x45, 0x43, 0xBD } },// 90 normal
            { 0xD, new byte[] {0xDF, 0xF3, 0xFC, 0xD6, 0x08, 0xB0, 0x55, 0x97, 0xCF, 0x09, 0xA2, 0x3B, 0xD1, 0x7D, 0x3F, 0xD2 } },// 93, 95, 96 normal
            { 0xD9, new byte[] {0xC7, 0xAC, 0x13, 0x06, 0xDE, 0xFE, 0x39, 0xEC, 0x83, 0xA1, 0x48, 0x3B, 0x0E, 0xE2, 0xEC, 0x89} } // 90 FSM
            };
        static readonly Dictionary<byte, byte[]> challenge1_secret = new Dictionary<byte, byte[]>()
            {
            { 0, new byte[] {0xD2, 0x07, 0x22, 0x53, 0xA4, 0xF2, 0x74, 0x68} },
            { 1, new byte[] {0xF5, 0xD7, 0xD4, 0xB5, 0x75, 0xF0, 0x8E, 0x4E} },
            { 2, new byte[] {0xB3, 0x7A, 0x16, 0xEF, 0x55, 0x7B, 0xD0, 0x89} },
            { 3, new byte[] {0xCC, 0x69, 0x95, 0x81, 0xFD, 0x89, 0x12, 0x6C} },
            { 4, new byte[] {0xA0, 0x4E, 0x32, 0xBB, 0xA7, 0x13, 0x9E, 0x46} },
            { 5, new byte[] {0x49, 0x5E, 0x03, 0x47, 0x94, 0x93, 0x1D, 0x7B} },
            { 6, new byte[] {0xB0, 0xB8, 0x09, 0x83, 0x39, 0x89, 0xFA, 0xE2} },
            { 8, new byte[] {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00} },
            { 0xA, new byte[] {0xC2, 0x37, 0x7E, 0x8A, 0x74, 0x09, 0x6C, 0x5F} },
            { 0xD, new byte[] {0x58, 0x1C, 0x7F, 0x19, 0x44, 0xF9, 0x62, 0x62} },
            { 0x2F, new byte[] {0xC9, 0xF8, 0x09, 0x45, 0x2A, 0xA2, 0xBE, 0xD5} },
            { 0xD9, new byte[] {0x90, 0xE1, 0xF0, 0xC0, 0x01, 0x78, 0xE3, 0xFF} }
            };
        static readonly Dictionary<byte, byte[]> challenge2_secret = new Dictionary<byte, byte[]>()
            {
            { 0, new byte[] { 0xF4, 0xE0, 0x43, 0x13, 0xAD, 0x2E, 0xB4, 0xDB } },
            { 1, new byte[] { 0xFE, 0x7D, 0x78, 0x99, 0xBF, 0xEC, 0x47, 0xC5 } },
            { 2, new byte[]{ 0x86, 0x5E, 0x3E, 0xEF, 0x9D, 0xFB, 0xB1, 0xFD } },
            { 3, new byte[]{ 0x30, 0x6F, 0x3A, 0x03, 0xD8, 0x6C, 0xBE, 0xE4 } },
            { 4, new byte[]{ 0xFF, 0x72, 0xBD, 0x2B, 0x83, 0xB8, 0x9D, 0x2F } },
            { 5, new byte[]{ 0x84, 0x22, 0xDF, 0xEA, 0xE2, 0x1B, 0x63, 0xC2 } },
            { 6, new byte[]{ 0x58, 0xB9, 0x5A, 0xAE, 0xF3, 0x99, 0xDB, 0xD0 } },
            { 8, new byte[] { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 } },
            { 0xA, new byte[]{ 0x09, 0x3E, 0xC5, 0x19, 0xAF, 0x0F, 0x50, 0x2D } },
            { 0xD, new byte[]{ 0x31, 0x80, 0x53, 0x87, 0x5C, 0x20, 0x3E, 0x24 } },
            { 0x2F, new byte[] {0x40, 0xD0, 0x2B, 0xAC, 0xFB, 0x1A, 0x8B, 0xEA} },
            { 0xD9, new byte[]{ 0xC3, 0x4A, 0x6A, 0x7B, 0x20, 0x5F, 0xE8, 0xF9 } }
            };

        [STAThread]
        static void Main(string[] args)
        {
            AttachConsole(ATTACH_PARENT_PROCESS);
            Console.WriteLine("");
            if (args.Length == 0)
            { 
                usingGui = true;
                Application.EnableVisualStyles();
                Application.SetCompatibleTextRenderingDefault(false); 
                Application.Run(new Form1());

            }
            else if (args.Length != 1)
            {
                UsageError(1);
            }
            else if (args.Length == 1) 
            {
                string[] ports = SerialPort.GetPortNames();
                if (args[0] == "list")
                {
                    if (ports.Length == 0)
                    {
                        Console.WriteLine("No ports available.");

                    }
                    foreach (string port in ports)
                    {
                        Console.WriteLine(port);
                    }
                }
                else if (!ports.Contains(args[0]) && args[0].Contains("COM"))
                {
                    UsageError(2);
                }
                else if (ports.Contains(args[0]))
                {
                    Console.WriteLine("Input serial number (0-9 A-F), 8 symbols");
                    string serialstr = Console.ReadLine();
                    StartSerialEmulation(args[0], serialstr);
                }
                else UsageError(1);
            }

        }
        static void UsageError(int errNum)
        {
            switch (errNum)
            {
                case 1:
                    Console.WriteLine("Usage: baryonswp.exe <PSP(tm) COM port>");
                    Console.WriteLine("Alternatively, use 'baryonswp.exe list' to list available COM ports.");
                    break;
                case 2:
                    Console.WriteLine("Specified COM port does not exist!");
                    Console.WriteLine("Use 'baryonswp.exe list' to list available COM ports.");
                    break;
            }
        }
        static void log(string msg)
        {
            if (!usingGui) Console.WriteLine(msg);
            else 
            {
                
                frm1.LogToTextbox(msg);
            }
        }
        public static void StartSerialEmulation(string portName, string serial)
        {
            serialPortInstance = new SerialPort(portName)
            {
                BaudRate = 19200,
                Parity = Parity.Even,
                StopBits = StopBits.One,
                DataBits = 8,
                Handshake = Handshake.None
            };

            log("Initialized port " + portName);
            
            try { serialPortInstance.Open(); }
            catch { log("Port is taken by another application or something is wrong with it. Try again."); return; }
            
            byte[] pspdata = new byte[4];
            if (serial.Length == 8) log("Using serial number " + serial);
            else { Console.WriteLine("Serial number must be 8 characters long."); serialPortInstance.Close(); return; }
            log("Service ready. Please connect your PSP™.");
            
            while (serialPortInstance.IsOpen)
            {
                try { if (serialPortInstance.BytesToRead >= 4)
                    {
                        pspdata[0] = (byte)serialPortInstance.ReadByte();
                        if (pspdata[0] == 0x5A)
                        {
                            pspdata[1] = (byte)serialPortInstance.ReadByte();               // packet length
                            pspdata[2] = (byte)serialPortInstance.ReadByte();               // operation code
                            if (pspdata[1] == 0x02)                             // if packet has no message then byte after the opcode is the checksum
                            {
                                pspdata[3] = (byte)serialPortInstance.ReadByte();           // checksum
                                log(BitConverter.ToString(pspdata).Replace("-", " "));
                            }
                            else  // packet contains a message
                            {
                                int msgLength = ((int)pspdata[1] - 2); // operation code is read already (-1); packet len includes
                                                                       // checksum so to  get actual msg length we do -1 again                        
                                while (serialPortInstance.BytesToRead < (int)pspdata[1] - 1) { System.Threading.Thread.Sleep(10); }; // wait until bytestoread has remaining msg and csum (opcode is already read so -1)
                                msg = new byte[msgLength];
                                for (int i = 0; i < msgLength; i++) msg[i] = (byte)serialPortInstance.ReadByte();
                                pspdata[3] = (byte)serialPortInstance.ReadByte();
                                byte[] h1 = new byte[3];
                                for (int i = 0; i < 3; i++) h1[i] = pspdata[i];
                                log(BitConverter.ToString(h1).Replace("-", " ") + " " + BitConverter.ToString(msg).Replace("-", "") + " " + pspdata[3].ToString("X"));
                            }

                            switch (pspdata[2])
                            {
                                case 0x01:
                                    byte[] answer = new byte[] { 0xA5, 0x05, 0x06, 0x10, 0xC3, 0x06, 0x76 };
                                    byte[] h1 = new byte[3]; for (int i = 0; i < 3; i++) h1[i] = answer[i];
                                    log("A5 05 06 10C306 76");
                                    serialPortInstance.Write(answer, 0, answer.Length);
                                    break;
                                case 0x0c:
                                    byte[] headersn = new byte[] { 0xA5, 0x06, 0x06 };
                                    byte[] serialno = StringToByteArray(serial);
                                    byte[] tempsn = new byte[7];
                                    byte[] tempsnLE = new byte[4];
                                    int[] order = new int[4] { 1, 0, 3, 2 };
                                    for (int i = 0; i < 4; i++) tempsnLE[i] = serialno[order[i]];
                                    Array.Copy(headersn, tempsn, headersn.Length);
                                    Array.Copy(tempsnLE, 0, tempsn, 3, serialno.Length);
                                    log(BitConverter.ToString(headersn).Replace("-", " ") + " " + BitConverter.ToString(tempsnLE).Replace("-", "") + " " + GeneratePacketChecksum(tempsn).ToString("X"));
                                    serialPortInstance.Write(tempsn, 0, tempsn.Length);
                                    byte[] tempsn1 = new byte[1];
                                    tempsn[0] = GeneratePacketChecksum(tempsn);
                                    serialPortInstance.Write(tempsn, 0, tempsn.Length);
                                    break;
                                case 0x80:
                                    generateSysconResponses(msg);
                                    // create 19 byte long byte array  (a5 12 06 + bytes from response 1a + bytes from response 1b) and calculate
                                    // its checksum using GeneratePacketChecksum
                                    // send the array and checksum over serial
                                    byte[] header = new byte[3] { 0xA5, 0x12, 0x06 };
                                    byte[] temp = new byte[19];
                                    Array.Copy(header, temp, 3);
                                    Array.Copy(response1a, 0, temp, 3, response1a.Length);
                                    Array.Copy(response1b, 0, temp, (3 + response1a.Length), response1b.Length);
                                    byte[] temp111 = new byte[1];
                                    temp111[0] = GeneratePacketChecksum(temp);
                                    log(BitConverter.ToString(header).Replace("-", " ") + " " + BitConverter.ToString(response1a).Replace("-", "") + " " + BitConverter.ToString(response1b).Replace("-", "") + " " + BitConverter.ToString(temp111));
                                    serialPortInstance.Write(header, 0, header.Length);
                                    serialPortInstance.Write(response1a, 0, response1a.Length);
                                    serialPortInstance.Write(response1b, 0, response1b.Length);
                                    serialPortInstance.Write(temp111, 0, 1);
                                    /*
                                    byte[] crutch = new byte[] { 0xA5, 0x12, 0x06, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x52 };
                                    log("A5 12 06 FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF 52");
                                    serialPortInstance.Write(crutch, 0, crutch.Length);
                                    */
                                    break;
                                case 0x81:
                                    byte[] header1 = new byte[3] { 0xA5, 0x0A, 0x06 };
                                    byte[] temp1 = new byte[11];
                                    Array.Copy(header1, temp1, 3);
                                    Array.Copy(response2g, 0, temp1, 3, response2g.Length);
                                    log(BitConverter.ToString(header1).Replace("-", " ") + " " + BitConverter.ToString(response2g).Replace("-", "") + " " + temp1[0].ToString("X"));
                                    serialPortInstance.Write(temp1, 0, temp1.Length);
                                    temp1[0] = GeneratePacketChecksum(temp1);
                                    serialPortInstance.Write(temp1, 0, 1);
                                    break;
                                case 0x03:
                                    byte[] answer3 = new byte[] { 0xA5, 0x04, 0x06, 0x36, 0x10, 0x0A };
                                    log("A5 04 06 3610 0A");
                                    serialPortInstance.Write(answer3, 0, answer3.Length);
                                    break;
                                case 0x07:
                                    byte[] answer4 = new byte[] { 0xA5, 0x04, 0x06, 0x08, 0x07, 0x41 };
                                    log("A5 04 06 0807 41");
                                    serialPortInstance.Write(answer4, 0, answer4.Length);
                                    break;
                                case 0x0B:
                                    byte[] answer5 = new byte[] { 0xA5, 0x04, 0x06, 0x0F, 0x00, 0x41 };
                                    log("A5 04 06 0F00 41");
                                    serialPortInstance.Write(answer5, 0, answer5.Length);
                                    break;
                                case 0x09:
                                    byte[] answer6 = new byte[] { 0xA5, 0x04, 0x06, 0x01, 0x04, 0x4B };
                                    log("A5 04 06 0104 4B");
                                    serialPortInstance.Write(answer6, 0, answer6.Length);
                                    break;
                                case 0x02:
                                    byte[] answer7 = new byte[] { 0xA5, 0x03, 0x06, 0x1B, 0x36 };
                                    log("A5 03 06 1B 36");
                                    serialPortInstance.Write(answer7, 0, answer7.Length);
                                    break;
                                case 0x04:
                                    byte[] answer8 = new byte[] { 0xA5, 0x04, 0x06, 0x68, 0x10, 0xD8 };
                                    log("A5 04 06 6810 D8");
                                    serialPortInstance.Write(answer8, 0, answer8.Length);
                                    break;
                            }
                        }
                    }
                }
                catch { log("Port disconnected, please try starting the service again."); serialPortInstance.Close(); return; }
            }
            serialPortInstance.Close();
            log("Service stopped.");
        }

        public static byte[] MixChallenge1(byte version, byte[] challenge)
        {
            byte[] data = new byte[] { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

            byte[] secret1 = challenge1_secret[version];
            data[0] = secret1[0];
            data[4] = secret1[1];
            data[8] = secret1[2];
            data[0xC] = secret1[3];
            data[1] = secret1[4];
            data[5] = secret1[5];
            data[9] = secret1[6];
            data[0xD] = secret1[7];
            data[2] = challenge[0];
            data[6] = challenge[1];
            data[0xA] = challenge[2];
            data[0xE] = challenge[3];
            data[3] = challenge[4];
            data[7] = challenge[5];
            data[0xB] = challenge[6];
            data[0xF] = challenge[7];
            //Console.WriteLine("MixChallenge 1 result: " + BitConverter.ToString(data).Replace(" - ", " "));
            return data;
        }
        public static byte[] MixChallenge2(byte version, byte[] challenge)
        {
            byte[] data = new byte[] { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
            byte[] secret2 = challenge2_secret[version];
            data[0] = challenge[0];
            data[4] = challenge[1];
            data[8] = challenge[2];
            data[0xC] = challenge[3];
            data[1] = challenge[4];
            data[5] = challenge[5];
            data[9] = challenge[6];
            data[0xD] = challenge[7];
            data[2] = secret2[0];
            data[6] = secret2[1];
            data[0xA] = secret2[2];
            data[0xE] = secret2[3];
            data[3] = secret2[4];
            data[7] = secret2[5];
            data[0xB] = secret2[6];
            data[0xF] = secret2[7];
            //Console.WriteLine("MixChallenge 2 result: " + BitConverter.ToString(data).Replace(" - ", " "));
            return data;
        }
        public static byte[] MatrixSwap(byte[] key)
        {
            byte[] temp = new byte[] { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
            byte[] newmap = new byte[] { 0x00, 0x04, 0x08, 0x0C, 0x01, 0x05, 0x09, 0x0D, 0x02, 0x06, 0x0A, 0x0E, 0x03, 0x07, 0x0B, 0x0F };
            int keyLen = key.Length;
            for (int i = 0; i < keyLen; i++)
            {
                temp[i] = key[newmap[i]];
            }
            //Console.WriteLine("Matrix Swap result: " + BitConverter.ToString(temp).Replace(" - ", " "));
            return temp;
        }
        public static void generateSysconResponses(byte[] response)
        {
            byte[] screq = response;
            byte version = screq[0];
            byte[] req = screq.Skip(1).ToArray();
            byte[] data = MixChallenge1(version, req);
            byte[] challenge1aes = new byte[8];
            challenge1aes = ECBEncryptBytes(MatrixSwap(data), keystore[version]);
            byte[] challenge1a = new byte[8];
            for (int i = 0; i < 8; i++) challenge1a[i] = challenge1aes[i];
            byte[] challenge1baes = ECBEncryptBytes(challenge1a, keystore[version]);
            response1a = challenge1a; // is correct
            response1b = new byte[8]{0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA}; // no double aes as Proxima told me to try
            byte[] data2 = MixChallenge2(version, response1b);
            byte[] challenge2aes = ECBEncryptBytes(MatrixSwap(data2), keystore[version]);
            byte[] challenge2 = new byte[8];
            for (int i = 0; i < 8; i++) challenge2[i] = challenge2aes[i];
            // log("5A 0A 81 challenge msg should be as follows: " + BitConverter.ToString(challenge2).Replace("-", ""));
            byte[] response2aes = ECBEncryptBytes(challenge2aes, keystore[version]);
            for (int i = 0; i < 8; i++) response2g[i] = response2aes[i];
            /*
            response1b = challenge1b;
            
            byte[] data2 = MixChallenge2(version, challenge1b);
            byte[] challenge2aes = new byte[8];
            challenge2aes = ECBEncryptBytes(MatrixSwap(data2), keystore[version]);
            byte[] challenge2 = new byte[8];
            for (int i = 0; i < 8; i++) challenge2[i] = challenge2aes[i];
            byte[] response2aes = new byte[8];
            response2aes = ECBEncryptBytes(challenge2aes, keystore[version]);
            byte[] response2 = new byte[8];
            for (int i = 0; i < 8; i++) response2[i] = response2aes[i];
            response2g = response2;
            */
        }
        private static byte[] ECBEncryptBytes(byte[] clearBytes, byte[] key)
        {
            byte[] encryptedBytes = null;
            // create an AES object
            using (Aes aes = new AesManaged())
            {
                aes.KeySize = 128;
                aes.Key = key;
                aes.Mode = CipherMode.ECB;

                using (MemoryStream ms = new MemoryStream())
                {
                    using (CryptoStream cs = new CryptoStream(ms, aes.CreateEncryptor(), CryptoStreamMode.Write))
                    {
                        cs.Write(clearBytes, 0, clearBytes.Length);
                        cs.Close();
                    }
                    encryptedBytes = ms.ToArray();
                }
            }
            return encryptedBytes;
        }
        private static byte GeneratePacketChecksum(byte[] inputArray) // array with every sigle byte of packet w/o checksum
        {
            int sum = 0;
            for (int i = 0; i < inputArray.Length; i++)
            {
                sum += inputArray[i];
            }
            string hexValue = sum.ToString("X");
            if (hexValue.Length > 2) hexValue = hexValue.Remove(0, hexValue.Length - 2); // trunctate
            byte temp = Convert.ToByte(hexValue.Substring(0, 2), 16);           // convert it to byte    
            byte ret = Convert.ToByte(0xFF - Convert.ToInt32(temp));
            return ret;
            //return Convert.ToByte(0xFF);
        }
        public static byte[] StringToByteArray(string hex)
        {
            return Enumerable.Range(0, hex.Length)
                             .Where(x => x % 2 == 0)
                             .Select(x => Convert.ToByte(hex.Substring(x, 2), 16))
                             .ToArray();
        }
    }
}


